
/* ---------------------------------------------------------------------------
   A. Veneziani - Soluzione di una funzione
   Scritto con C++ Builder 6
   --------------------------------------------------------------------------- */

#include "stdio.h"
#include "conio.h"

/* definisce una costante che fissa il passo di scansione
   nell' effettuare la ricerca degli zeri                  */
#define PASSO_SCANSIONE 0.01

int main()
{
    float x, y;
    int segno_funz, segno_prec;

    /* ciclo di scansione con il passo previsto
       da -x a x (in questo caso da -10 a 10)     */
    segno_prec = -1;
    for (x = -10; x < 10; x = x + PASSO_SCANSIONE)
    {
        /* polinomio di primo grado (retta)  avente una sola soluzione */
        y = 5 * x + 3;

        /* controlla il segno della funzione analizzata nel punto x corrente */
        /* (positivo = 1, negativo = 0)                                      */
        if (y > 0)
           segno_funz = 1;
        else
           segno_funz = 0;

        /* controlla eventuali variazioni rispetto al segno al passo precedente */
        if (segno_prec != -1)
        {
           /* se i due segni non sono uguali allora vuol dire che
              e' stato rilevato uno zero                           */
           if (segno_prec != segno_funz)
               printf("E' stato rilevato uno zero in: %f \n", x);
        }

        /* viene assegnato il valore del segno corrente */
        segno_prec = segno_funz;
    }

    getch();      /* ferma l'il programma prevenendone l'uscita immediata */

    return 0;
}

 